' StoryTool.vbs, ver. 1.4, 17-09-99

' - Builds a sequence of html pages out of numbered picture and text files

'   The raw material for each page is stored in files with an arbitrary
'   name root such as 'kuva' for the picture and 'teksti' for the text.
'   The position of the page is indicated with a three number digit: 
'   e.g. kuva002.gif and teksti002.txt
'   The script generates image links for the 'back.gif' and 
'   'forward.gif' browsing buttons, which should have disabled
'   counterparts 'disback.gif' and 'disforward.gif' in order to 
'   signal end states.

' Updates:
'   18-08-98	Completed conversion AnsiToHtml from 
'         	ansi character set to HTML mnemonics
'   19-08-08	Created an algoritm allowing use of a 
'         	single template file
'   17-09-99	Translated comments into 'English'

' Toiveet:
' - Yleist niin ett kyttj voi valita mink tahansa juuren
'   kuvien ja tekstien nimiksi
' - Talleta koodirivit suoraan tekstistreamiin
' - Template.txt asiakirjaan tytyy list navigointi nuolia selittvt
'   alt -mreet jotta sivut validoituisivat

Sub Main ()
	' Build pages for range 0-22
	GeneratePages 0, 22
	MsgBox "Generated pages", vbInformation
End Sub

Sub GeneratePages (nFirst, nLast)
	' Short-hand
	strPath = "\\Ilmari\Usr\users\pdonner\SekvTest 1\"

	' Create first page
	SavePage GetFileName (strPath & "page", nFirst, "htm"), BuildPage (nFirst, 1, 0)

	n = nFirst + 1
	While (n < nLast)
		SavePage GetFileName (strPath & "page", n, "htm"), BuildPage (n, 0, 0)
		n = n + 1
	Wend

	' Create last page
	SavePage GetFileName (strPath & "page", nLast, "htm"), BuildPage (nLast, 0, 1)
End Sub

Sub SavePage (strFilespec, strText)
	Set fs = CreateObject("Scripting.FileSystemObject")
	Set a = fs.CreateTextFile(strFilespec, True)
	a.Write(strText)
	a.Close
End Sub

Function BuildPage (nNumber, bFirst, bLast)
	Dim fs, f1, ts1, strPage
	strQuote = Chr(34)
	strPageRoot = "page"
	strPictRoot = "Picture/auk"
	strTextRoot = "Text/teksti"

	strBack = "Back.gif"
	strForward = "Forward.gif"
	strDisBack = "DisBack.gif"
	strDisForward = "DisForward.gif"

	strPath = "\\Ilmari\Usr\users\pdonner\SekvTest 1\"

	Set fs = CreateObject("Scripting.FileSystemObject")
	Set objFile = fs.GetFile(strPath & "Template.txt")    
	Set objStream = objFile.OpenAsTextStream ()

	' Build the Head
	strPage = ReadCodeLines (objStream)
	strPage = strPage & "   <TITLE>Page " & ZeroTrail (nNumber) & "</TITLE>" + vbCrlf

	' Build the Body
	strPage = strPage & ReadCodeLines (objStream)

	If (bFirst) Then
		strPage = strPage & "   <A HREF=" & InQuotes(GetFileName (strPageRoot, nNumber, "htm"))& ">" & vbCrlf
		strPage = strPage & "   <IMG SRC=" & InQuotes (strDisBack) & " HEIGHT=42 WIDTH=62></A>" & vbCrlf
	Else
		strPage = strPage & "   <A HREF=" & InQuotes(GetFileName (strPageRoot, nNumber - 1, "htm"))& ">" & vbCrlf
		strPage = strPage & "   <IMG SRC=" & InQuotes (strBack) & " HEIGHT=42 WIDTH=62></A>" & vbCrlf
	End If

	strPage = strPage & vbCrlf & "   &nbsp;" & vbCrlf

	If (bLast) Then
		strPage = strPage & "   <A HREF=" & InQuotes(GetFileName (strPageRoot, nNumber, "htm"))& ">" & vbCrlf
		strPage = strPage & "   <IMG SRC=" & InQuotes (strDisForward) & " HEIGHT=42 WIDTH=62></A>" & vbCrlf
	Else
		strPage = strPage & "   <A HREF=" & InQuotes(GetFileName (strPageRoot, nNumber + 1, "htm"))& ">" & vbCrlf
		strPage = strPage & "   <IMG SRC=" & InQuotes (strForward) & " HEIGHT=42 WIDTH=62></A>" & vbCrlf
	End If

	strPage = strPage & ReadCodeLines (objStream)
	strPage = strPage & "   &nbsp;" & vbCrlf 

	' Build the picture paragraph
	strPage = strPage & "   <IMG SRC=" & InQuotes (strPictRoot & ZeroTrail (nNumber) & ".gif") & " HEIGHT=197 WIDTH=433>" & vbCrlf
	strPage = strPage & ReadCodeLines (objStream)

	' Insert the text file
	strPage = strPage & AnsiToHtml (GetFileText (strPath & strTextRoot & ZeroTrail (nNumber) & ".txt"))

	' Close the page
	BuildPage = strPage & ReadCodeLines (objStream)

	objStream.Close
End Function

Function ReadCodeLines (objTextStream)
	' Reads code lines from template 
	' - Bypasses comment lines beginning with '@@@', 
	'   then reads code until next comment

	Dim strCode, strLine

	' Pass all possible comment lines
	If (Not objTextStream.AtEndOfStream) Then
		strLine = objTextStream.ReadLine()
	End If

	While (Left (strLine, 3) = "@@@")
		strLine = objTextStream.ReadLine()
	Wend

	' Build a string of all subsequent code lines
	If (Not objTextStream.AtEndOfStream Or _
	    Len (strLine) > 0) Then
		strCode = strLine & vbCrlf
	End If

	strLine = objTextStream.ReadLine()

	While (Left (strLine, 3) <> "@@@" And _
		   Not objTextStream.AtEndOfStream)
		strCode = strCode & strLine & vbCrlf
		strLine = objTextStream.ReadLine()
	Wend

	' Add possible code line situated at file end 
	If (Left (strLine, 3) <> "@@@" And _
		objTextStream.AtEndOfStream) Then
		strCode = strCode & strLine & vbCrlf
	End If

	ReadCodeLines = strCode
End Function	

Function InQuotes (strText)

	' Inserts the parameter string 
	' within quotation marks

	InQuotes = Chr(34) & strText & Chr(34)
End Function

Function GetFileText (strFileref)
	Set fs = CreateObject("Scripting.FileSystemObject")
	Set f1 = fs.GetFile(strFileref)
	nSize = f1.Size
	Set ts1 = f1.OpenAsTextStream ()
	GetFileText = ts1.Read (nSize)
End Function

Function GetFileName (strRef, nNumber, strType)
	Dim strPath, strRoot

	' Dissect possible path
	nIndex = InStrRev (strRef, "\")

	If (nIndex > 0) Then
		strPath = Left(strRef, nIndex)
		strRoot = Mid(strRef, nIndex + 1)
	ElseIf (Mid(strRef, 2, 1) = ":") Then
		strPath = Left(strRef, 2)
		strRoot = Mid(strRef, 3)
	Else
		strPath = ""
		strRoot = strRef
	End If

	' Transform root into normalized form: 'ROOT' -> 'Root'
	strRoot = UCase(Left(strRoot, 1)) & LCase(Mid(strRoot,2))	

	' Append a three number sequence number and the possible file type
	If (Len(strType) > 1) Then
		GetFileName = strPath & strRoot & ZeroTrail (nNumber) & "." & LCase(strType)
	Else
		GetFileName = strPath & strRoot & ZeroTrail (nNumber)
	End If
End Function

Function ZeroTrail (nNumber)

	' Translate argument into an integer

	nNumber = Int(nNumber)

	If (nNumber > 999) Or (nNumber < 1) Then
		ZeroTrail = "000"
	ElseIf nNumber > 99 Then
		ZeroTrail = CStr (nNumber)
	ElseIf nNumber > 9 Then
		ZeroTrail = "0" & CStr (nNumber)
	Else
		ZeroTrail = "00" & CStr (nNumber)
	End If
End Function

Function AnsiToHtml (strIn)

	' Translates ansi character set into HTML mnemonics
	' and inserts line break tags at newline characters

	Dim strOut
	nLength = Len(strIn)

	n = 1
	While (n <= nLength)
		ch = Mid(strIn, n, 1)

		Select Case Asc(ch)
		case 10
		strOut = strOut & ch & "<BR>"

		case 34
		strOut = strOut & "&quot;" ' Quotation mark '"'

		case 38
		strOut = strOut & "&amp;" ' Ampersand '&'

		case 60
		strOut = strOut & "&lt;" ' Less than '<'

		case 62
		strOut = strOut & "&gt;" ' Greater than '>'

		case 160
		strOut = strOut & "&nbsp;" ' Non-breaking Space 

		case 161
		strOut = strOut & "&iexcl;"	' Inverted exclamation ''

		case 162
		strOut = strOut & "&cent;"	' Cent sign ''

		case 163
		strOut = strOut & "&pound;"	' Pound sterling ''

		case 164
		strOut = strOut & "&curren;" ' General currency sign ''

		case 165
		strOut = strOut & "&yen;"	' Yen sign ''

		case 166
		strOut = strOut & "&brkbar;" ' Broken vertical bar (sometimes &brvbar;) ''

		case 167
		strOut = strOut & "&&sect;"	' Section sign ''

		case 168
		strOut = strOut & "&&um;"	' Diresis / Umlaut (sometimes &&die;) ''

		case 169
		strOut = strOut & "&&copy;"	' Copyright '(c)'

		case 170
		strOut = strOut & "&&ordf;"	' Feminine ordinal ''

		case 171
		strOut = strOut & "&&laquo;" ' Left angle quote, guillemot left ''

		case 172
		strOut = strOut & "&&not;"	' Not sign ''

		case 173
		strOut = strOut & "&shy;"	' Soft hyphen ''

		case 174
		strOut = strOut & "&reg;"	' Registered trademark '(r)'

		case 175
		strOut = strOut & "&hibar;"	' Macron accent (sometimes &macr;) ''

		case 176
		strOut = strOut & "&deg;"	' Degree sign ''

		case 177
		strOut = strOut & "&plusmn;" ' Plus or minus ''

		case 178
		strOut = strOut & "&sup2;"	' Superscript two ''

		case 179
		strOut = strOut & "&sup3;"	' Superscript three ''

		case 180
		strOut = strOut & "&acute;"	' Acute accent ''

		case 181
		strOut = strOut & "&micro;"	' Micro sign ''

		case 182
		strOut = strOut & "&para;"	' Paragraph sign ''

		case 183
		strOut = strOut & "&middot;" ' Middle dot ''

		case 184
		strOut = strOut & "&cedil;"	' Cedilla ''

		case 185
		strOut = strOut & "&sup1;"	' Superscript one ''

		case 186
		strOut = strOut & "&ordm;"	' Masculine ordinal ''

		case 187
		strOut = strOut & "&raquo;"	' Right angle quote, guillemot right ''

		case 188
		strOut = strOut & "&frac14;" ' Fraction one-fourth '1/4'
 
		case 189
		strOut = strOut & "&frac12;" ' Fraction one-half '1/2'
 
		case 190
		strOut = strOut & "&frac34;" ' '3/4' Fraction three-fourths 

		case 191
		strOut = strOut & "&iquest;" ' '' Inverted question mark 
 
		case 192
		strOut = strOut & "&Agrave;" ' '' Capital A, grave accent 

		case 193
		strOut = strOut & "&Aacute;" ' '' Capital A, acute accent 

		case 194
		strOut = strOut & "&Acirc;" ' '' Capital A, circumflex 

		case 195
		strOut = strOut & "&Atilde;" ' '' Capital A, tilde 

		case 196
		strOut = strOut & "&Auml;" ' '' Capital A, diresis / umlaut 
 
		case 197
		strOut = strOut & "&Aring;" ' '' Capital A, ring 

		case 198
		strOut = strOut & "&AElig;" ' '' Capital AE ligature 

		case 199
		strOut = strOut & "&Ccedil;" ' '' Capital C, cedilla 
 
		case 200
		strOut = strOut & "&Egrave;" ' '' Capital E, grave accent 

		case 201
		strOut = strOut & "&Eacute;" ' '' Capital E, acute accent 
 
		case 202
		strOut = strOut & "&Ecirc;" ' '' Capital E, circumflex 
 
		case 203
		strOut = strOut & "&Euml;" ' '' Capital E, diresis / umlaut 
 
		case 204
		strOut = strOut & "&Igrave;" ' '' Capital I, grave accent 
 
		case 205
		strOut = strOut & "&Iacute;" ' '' Capital I, acute accent 
 
		case 206
		strOut = strOut & "&Icirc;" ' '' Capital I, circumflex 
 
		case 207
		strOut = strOut & "&Iuml;" ' '' Capital I, diresis / umlaut 
 
		case 208
		strOut = strOut & "&ETH;" ' '' Capital Eth, Icelandic 
 
		case 209
		strOut = strOut & "&Ntilde;" ' '' Capital N, tilde 
 
		case 210
		strOut = strOut & "&Ograve;" ' '' Capital O, grave accent 
 
		case 211
		strOut = strOut & "&Oacute;" ' '' Capital O, acute accent 
 
		case 212
		strOut = strOut & "&Ocirc;" ' '' Capital O, circumflex 
 
		case 213
		strOut = strOut & "&Otilde;" ' '' Capital O, tilde 
 
		case 214
		strOut = strOut & "&Ouml;" ' '' Capital O, diresis / umlaut 
 
		case 215
		strOut = strOut & "&times;" ' '' Multiply sign 
 
		case 216
		strOut = strOut & "&Oslash;" ' '' Capital O, slash 
 
		case 217
		strOut = strOut & "&Ugrave;" ' '' Capital U, grave accent 
 
		case 218
		strOut = strOut & "&Uacute;" ' '' Capital U, acute accent 

		case 219
		strOut = strOut & "&Ucirc;" ' '' Capital U, circumflex 
 
		case 220
		strOut = strOut & "&Uuml;" ' '' Capital U, diresis / umlaut 
 
		case 221
		strOut = strOut & "&Yacute;" ' '' Capital Y, acute accent 

		case 222
		strOut = strOut & "&THORN;" ' '' Capital Thorn, Icelandic 
 
		case 223
		strOut = strOut & "&szlig;" ' '' Small sharp s, German sz 
 
		case 224
		strOut = strOut & "&agrave;" ' '' Small a, grave accent 
 
		case 225
		strOut = strOut & "&aacute;" ' '' Small a, acute accent 

		case 226
		strOut = strOut & "&acirc;" ' '' Small a, circumflex 
 
		case 227
		strOut = strOut & "&atilde;" ' '' Small a, tilde 
 
		case 228
		strOut = strOut & "&auml;" ' '' Small a, diresis / umlaut 
 
		case 229
		strOut = strOut & "&aring;" ' '' Small a, ring 

		case 230
		strOut = strOut & "&aelig;" ' '' Small ae ligature 
 
		case 231
		strOut = strOut & "&ccedil;" ' '' Small c, cedilla 
 
		case 232
		strOut = strOut & "&egrave;" ' '' Small e, grave accent 

		case 233
		strOut = strOut & "&eacute;" ' '' Small e, acute accent 
 
		case 234
		strOut = strOut & "&ecirc;" ' '' Small e, circumflex 
 
		case 235
		strOut = strOut & "&euml;" ' '' Small e, diresis / umlaut 
 
		case 236
		strOut = strOut & "&igrave;" ' '' Small i, grave accent 
 
		case 237
		strOut = strOut & "&iacute;" ' '' Small i, acute accent 
 
		case 238
		strOut = strOut & "&icirc;" ' '' Small i, circumflex 
 
		case 239
		strOut = strOut & "&iuml;" ' '' Small i, diresis / umlaut 
 
		case 240
		strOut = strOut & "&eth;" ' '' Small eth, Icelandic 
 
		case 241
		strOut = strOut & "&ntilde;" ' '' Small n, tilde 
 
		case 242
		strOut = strOut & "&ograve;" ' '' Small o, grave accent 
 
		case 243
		strOut = strOut & "&oacute;" ' '' Small o, acute accent 
 
		case 244
		strOut = strOut & "&ocirc;" ' '' Small o, circumflex 
 
		case 245
		strOut = strOut & "&otilde;" ' '' Small o, tilde 
 
		case 246
		strOut = strOut & "&ouml;" ' '' Small o, diresis / umlaut 
 
		case 247
		strOut = strOut & "&divide;" ' '' Division sign 
 
		case 248
		strOut = strOut & "&oslash;" ' '' Small o, slash 
 
		case 249
		strOut = strOut & "&ugrave;" ' '' Small u, grave accent 
 
		case 250
		strOut = strOut & "&uacute;" ' '' Small u, acute accent 
 
		case 251
		strOut = strOut & "&ucirc;" ' '' Small u, circumflex 
 
		case 252
		strOut = strOut & "&uuml;" ' '' Small u, diresis / umlaut 
 
		case 253
		strOut = strOut & "&yacute;" ' '' Small y, acute accent 
 
		case 254
		strOut = strOut & "&thorn;" ' '' Small thorn, Icelandic 
 
		case 255
		strOut = strOut & "&yuml;" ' '' Small y, diresis / umlaut  

		case else
		strOut = strOut & ch

		End Select 

		n = n + 1
	Wend

	AnsiToHtml = strOut
End Function
